package com.example.firebaseauth.auth

import androidx.lifecycle.ViewModel
import androidx.lifecycle.ViewModelProvider

// To create instances of AuthViewModel
class AuthViewModelFactory(private val authRepository: AuthRepository) : ViewModelProvider.Factory {
    override fun <T : ViewModel> create(modelClass: Class<T>): T {
        if (modelClass.isAssignableFrom(AuthViewModel::class.java)) {
            @Suppress("UNCHECKED_CAST") // Safe cast because of the class check
            return AuthViewModel(authRepository) as T
        }
        throw IllegalArgumentException("Unknown ViewModel class")
    }
}